// Code generated by protoc-gen-go-aeus. DO NOT EDIT.
// source: organize.proto
// date: 2025-06-17 15:01:15

package pb

import (
	"git.nobla.cn/golang/aeus/transport/http"
	"context"
	"git.nobla.cn/golang/aeus/pkg/errors"
)

type UserServiceHttpServer interface {
	GetMenus(context.Context, *GetMenuRequest) (*GetMenuResponse, error)

	GetProfile(context.Context, *GetProfileRequest) (*GetProfileResponse, error)

	UpdateProfile(context.Context, *UpdateProfileRequest) (*UpdateProfileResponse, error)

	ResetPassword(context.Context, *ResetPasswordRequest) (*ResetPasswordResponse, error)

	GetPermissions(context.Context, *GetPermissionRequest) (*GetPermissionResponse, error)

	GetUserLabels(context.Context, *GetUserLabelRequest) (*GetUserLabelResponse, error)

	GetUserTags(context.Context, *GetUserTagRequest) (*GetUserTagResponse, error)
}

type DepartmentServiceHttpServer interface {
	GetDepartmentLabels(context.Context, *GetDepartmentLabelRequest) (*GetDepartmentLabelResponse, error)
}

type RoleServiceHttpServer interface {
	GetRoleLabels(context.Context, *GetRoleLabelRequest) (*GetRoleLabelResponse, error)

	GetRolePermissions(context.Context, *GetRolePermissionRequest) (*GetRolePermissionResponse, error)

	SaveRolePermission(context.Context, *SaveRolePermissionRequest) (*SaveRolePermissionResponse, error)
}

type AuthServiceHttpServer interface {
	Login(context.Context, *LoginRequest) (*LoginResponse, error)

	Logout(context.Context, *LogoutRequest) (*LogoutResponse, error)
}

type SettingServiceHttpServer interface {
	GetSetting(context.Context, *GetSettingRequest) (*GetSettingResponse, error)
}

// 获取用户菜单

func handleUserServiceGetMenus(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetMenuRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.GetMenus(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户信息

func handleUserServiceGetProfile(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetProfileRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.GetProfile(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 更新用户信息

func handleUserServiceUpdateProfile(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &UpdateProfileRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.UpdateProfile(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 重置用户密码

func handleUserServiceResetPassword(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &ResetPasswordRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.ResetPassword(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户权限

func handleUserServiceGetPermissions(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetPermissionRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.GetPermissions(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户标签

func handleUserServiceGetUserLabels(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetUserLabelRequest{}

		if res, err := s.GetUserLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取用户标签

func handleUserServiceGetUserTags(s UserServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetUserTagRequest{}

		if res, err := s.GetUserTags(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取部门标签

func handleDepartmentServiceGetDepartmentLabels(s DepartmentServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetDepartmentLabelRequest{}

		if res, err := s.GetDepartmentLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取角色标签

func handleRoleServiceGetRoleLabels(s RoleServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetRoleLabelRequest{}

		if res, err := s.GetRoleLabels(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

// 获取角色权限

func handleRoleServiceGetRolePermissions(s RoleServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetRolePermissionRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.GetRolePermissions(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleRoleServiceSaveRolePermission(s RoleServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &SaveRolePermissionRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.SaveRolePermission(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleAuthServiceLogin(s AuthServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &LoginRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.Login(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleAuthServiceLogout(s AuthServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &LogoutRequest{}

		if err := ctx.Bind(req); err != nil {
			return ctx.Error(errors.Invalid, err.Error())
		}

		if res, err := s.Logout(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func handleSettingServiceGetSetting(s SettingServiceHttpServer) http.HandleFunc {
	return func(ctx *http.Context) (err error) {
		req := &GetSettingRequest{}

		if res, err := s.GetSetting(ctx.Context(), req); err != nil {
			if er, ok := err.(*errors.Error); ok {
				return ctx.Error(er.Code, er.Message)
			} else {
				return ctx.Error(errors.Unavailable, err.Error())
			}
		} else {
			return ctx.Success(res)
		}
	}
}

func RegisterUserServiceRouter(hs *http.Server, s UserServiceHttpServer) {

	// Register handle GetMenus route
	hs.GET("/user/menus", handleUserServiceGetMenus(s))

	// Register handle GetProfile route
	hs.GET("/user/profile", handleUserServiceGetProfile(s))

	// Register handle UpdateProfile route
	hs.PUT("/user/profile", handleUserServiceUpdateProfile(s))

	// Register handle ResetPassword route
	hs.POST("/user/reset-password", handleUserServiceResetPassword(s))

	// Register handle GetPermissions route
	hs.GET("/user/permissions", handleUserServiceGetPermissions(s))

	// Register handle GetUserLabels route
	hs.GET("/user/labels", handleUserServiceGetUserLabels(s))

	// Register handle GetUserTags route
	hs.GET("/user/tags", handleUserServiceGetUserTags(s))

}

func RegisterDepartmentServiceRouter(hs *http.Server, s DepartmentServiceHttpServer) {

	// Register handle GetDepartmentLabels route
	hs.GET("/department/labels", handleDepartmentServiceGetDepartmentLabels(s))

}

func RegisterRoleServiceRouter(hs *http.Server, s RoleServiceHttpServer) {

	// Register handle GetRoleLabels route
	hs.GET("/role/labels", handleRoleServiceGetRoleLabels(s))

	// Register handle GetRolePermissions route
	hs.GET("/role/permissions", handleRoleServiceGetRolePermissions(s))

	// Register handle SaveRolePermission route
	hs.POST("/role/permissions", handleRoleServiceSaveRolePermission(s))

}

func RegisterAuthServiceRouter(hs *http.Server, s AuthServiceHttpServer) {

	// Register handle Login route
	hs.POST("/passport/login", handleAuthServiceLogin(s))

	// Register handle Logout route
	hs.POST("/passport/logout", handleAuthServiceLogout(s))

}

func RegisterSettingServiceRouter(hs *http.Server, s SettingServiceHttpServer) {

	// Register handle GetSetting route
	hs.GET("/system/setting", handleSettingServiceGetSetting(s))

}
